//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Main.h"
#include "config.h"
#include "comment.h"
#include "about.h"
#include <time.h>
#include <stdio.h>
#include <sys\timeb.h>

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
Tcc *cc;

enum turn {PLAYER,COMPUTER};
enum heuristic {RANDOM,AB1,AB2,AB3,AB4};
char buffer[1000];

//stats
long noofnodes=0;
long totalnodeso,totalnodesr,noofmoveso,noofmovesr;
long timet,totaltimeo,totaltimer;

/*
C code
*/

char heuristics[5][50]={"Random","Vertical","VH","VHSplit","VHSBack"};


//optimize movegen ?
bool opt=true;
int DEEP_ENOUGH=3;
bool sort=true;
bool best=true;

// Game parameters( const )
int computerheuristic[2]={AB3,AB3};
int players[2]={PLAYER,COMPUTER};
int plieso=3,pliesr=3;
int INF=32760;
int h23_p1 = 3;
bool opto = true;
bool optr = true;

bool sorto=true;
bool sortr=true;

bool besto=true;
bool bestr=true;


const int squaresize=12;
const int xoffset=-50,yoffset=12;
int blinkcount=1;



// board data____
char boardconfig[289];
int squareposclicked=-1;
int currentturn=0; // decides player 0 or 1 for current move
bool moveover=false; // for timer
char playerpiece,computerpiece;
bool playermove=false;
char turnconfig=0; // 0 - Player ist move ,  1 - Player second move , 2 - Computer's move
int from,to;
bool gameinprogress=false;
bool paused=false;

//-----------------------------------GENERAL functions-----------------

// __returns coordinates for a square no for drawing the board
void get_position(int pos,int&x,int&y)
{
    x=((16-pos/17)+(pos%17)*2)*squaresize+xoffset;
    y=(pos/17)*2*squaresize+yoffset;
}

// this function returns the corresponding box no for a jump direction

int jump(int pos,char direction)
{
    if(direction==1)
        return pos-18;
    if(direction==2)
        return pos-17;
    if(direction==3)
        return pos+1;
    if(direction==4)
        return pos+18;
    if(direction==5)
        return pos+17;
    if(direction==6)
        return pos-1;

    return -1;
}

// return all the allowed moves in array positions based on the current place prev
void getalljumps(int prev,bool* positions)
{
    int i,j;

    // check for jumps in six directions

    i=jump(prev,1); // check for first jump
    j=jump(i,1); // check for second jump

    if(i>=0 && boardconfig[i]!='c' && boardconfig[i]!='0' && j>=0 && boardconfig[j]=='c' && positions[j]==false) // not blocked
    {
        positions[j]=true;
        getalljumps(j,positions);
    }

    i=jump(prev,2);
    j=jump(i,2);

    if(i>=0 && boardconfig[i]!='c' && boardconfig[i]!='0' && j>=0 && boardconfig[j]=='c' && positions[j]==false) // not blocked
    {
        positions[j]=true;
        getalljumps(j,positions);
    }

    i=jump(prev,3);
    j=jump(i,3);

    if(i<=288 && boardconfig[i]!='c' && boardconfig[i]!='0' && j<=288 && boardconfig[j]=='c' && positions[j]==false) // not blocked
    {
        positions[j]=true;
        getalljumps(j,positions);
    }

    i=jump(prev,4);
    j=jump(i,4);

    if(i<=288 && boardconfig[i]!='c' && boardconfig[i]!='0' && j<=288 && boardconfig[j]=='c' && positions[j]==false) // not blocked
    {
        positions[j]=true;
        getalljumps(j,positions);
    }

    i=jump(prev,5);
    j=jump(i,5);

    if(i<=288 && boardconfig[i]!='c' && boardconfig[i]!='0' && j<=288 && boardconfig[j]=='c' &&  positions[j]==false) // not blocked
    {
        positions[j]=true;
        getalljumps(j,positions);
    }

    i=jump(prev,6);
    j=jump(i,6);

    if(i>=0 && boardconfig[i]!='c' && boardconfig[i]!='0' && j>=0 && boardconfig[j]=='c' &&  positions[j]==false) // not blocked
    {
        positions[j]=true;
        getalljumps(j,positions);
    }


}

void getallowedmoves(int prev,bool* positions)
{
    int i;

    // check for jumps in six directions
    for(i=0;i<289;i++)
        positions[i]=false;

    i=jump(prev,1); // check for first jump
    if(i>=0 && boardconfig[i]=='c' && positions[i]==false)
        positions[i]=true;

    i=jump(prev,2);
    if(i>=0 && boardconfig[i]=='c' && positions[i]==false)
        positions[i]=true;


    i=jump(prev,3);
    if(i<=288 && boardconfig[i]=='c' && positions[i]==false)
        positions[i]=true;


    i=jump(prev,4);
    if(i<=288 && boardconfig[i]=='c' && positions[i]==false)
        positions[i]=true;

    i=jump(prev,5);
    if(i<=288 && boardconfig[i]=='c' && positions[i]==false)
        positions[i]=true;

    i=jump(prev,6);
    if(i>=0 && boardconfig[i]=='c' && positions[i]==false)
        positions[i]=true;

    getalljumps(prev,positions);

}


void message(char* s)
{
    Application->MessageBox(s,"cc",1);

}


//------------------COMPUTER PLAYER CODE HERE---------------------

/*
this function when called moves for the computer according to the
computerpiece and computerheuristic[currentturn] and then
sets the boardconfig
*/

bool win()
{
    int r=0,o=0;

    if(boardconfig[4]=='o')
        o++;
    if(boardconfig[21]=='o')
        o++;
    if(boardconfig[22]=='o')
        o++;
    if(boardconfig[38]=='o')
        o++;
    if(boardconfig[39]=='o')
        o++;
    if(boardconfig[40]=='o')
        o++;
    if(boardconfig[55]=='o')
        o++;
    if(boardconfig[56]=='o')
        o++;
    if(boardconfig[57]=='o')
        o++;
    if(boardconfig[58]=='o')
        o++;

    if(o==10)
        return true;

    if(boardconfig[230]=='r')
        r++;
    if(boardconfig[231]=='r')
        r++;
    if(boardconfig[232]=='r')
        r++;
    if(boardconfig[233]=='r')
        r++;
    if(boardconfig[248]=='r')
        r++;
    if(boardconfig[249]=='r')
        r++;
    if(boardconfig[250]=='r')
        r++;
    if(boardconfig[266]=='r')
        r++;
    if(boardconfig[267]=='r')
        r++;
    if(boardconfig[284]=='r')
        r++;

    if(r==10)
        return true;


    return false;

}

void Copy(char * a, char* b)
{
    //strncpy(b,a,289);
    for(int i=0;i<289;i++)
        b[i] = a[i];
}

void p(char* a,int i,char* c)
{

    return;
    //message("here at p");
    sprintf(buffer,"%s %d : %s \n",a,i,c);
    cc->list->Items->Add(buffer);
    // char c1[289];
    //strncpy(c1,boardconfig,289);
    // strncpy(boardconfig,c,289);
    //cc->paintboard();
    // strncpy(boardconfig,c1,289);
    // message(buffer);
}

int SEF(char* b,char player,int sef)
{
    int rv=0;
    int rn,i;
    int mv;
    switch(sef)
    {
        case 4 :
            for(i=0;i<289;i++)
            {
                if(b[i]=='r')
                {
                    rn = i/17;
                    rv+=rn*h23_p1;
                    break;
                }
            }
            for(i=288;i>=0;i--)
            {
                if(b[i]=='o')
                {
                    rn = 16-i/17;
                    rv-=rn*h23_p1;
                    break;
                }
            }



            /*   		int lm1,lm2,olm1,olm2;
                       int p=0,op=0;
            for(i=0;i<289;i++)
                   	{
                      	if(b[i]=='r')
                       {
                       	p++;
                       	rn = i/17;
                           if(p==1)
                           	lm1 = rn;
                           else if(p==2)
                           {
                               lm2 = rn;
                               rv += min(lm2-lm1,lm1);
                           }
                           else if(p==3)
                           {
                            	rv+=min(rn-lm1,lm1);
                               rv+=min(rn-lm2,lm2);
                           }
                           else if(p==4)
                           {
                            	rv+=min(rn-lm1,lm1);
                               rv+=min(rn-lm2,lm2);
                           }
                           mv = abs(i - rn*17.5 - 4);
                           rv+=(rn*h23_p1 - mv);
                       }
                       }
                       for(i=288;i>=0;i--)
                       {
                       if(b[i]=='o')
                       {
                       	op++;
                       	rn = 16 - i/17;
                           if(op==1)
                           	olm1 = rn;
                           else if(op==2)
                           {
                               olm2 = rn;
                               rv -= min(olm2-olm1,olm1);
                           }
                           else if(op==3)
                           {
                            	rv-=min(rn-olm1,olm1);
                               rv-=min(rn-olm2,olm2);
                           }
                           else if(op==4)
                           {
                            	rv-=min(rn-olm1,olm1);
                               rv-=min(rn-olm2,olm2);
                           }
                           mv = abs(i - (16-rn)*17.5 - 4);
                           rv-=(rn*h23_p1 - mv);
                       }
                       }
            */

        case 3 :
            if(b[55]=='o')
                rv-= 10;
            if(b[56]=='o')
                rv-= 5;
            if(b[57]=='o')
                rv-= 5;
            if(b[58]=='o')
                rv-= 10;
            if(b[38]=='o')
                rv-= 10;
            if(b[39]=='o')
                rv-= 5;
            if(b[40]=='o')
                rv-= 10;
            if(b[21]=='o')
                rv-= 10;
            if(b[22]=='o')
                rv-= 10;
            if(b[4]=='o')
                rv-= 10;


            if(b[230]=='r')
                rv+= 10;
            if(b[231]=='r')
                rv+= 5;
            if(b[232]=='r')
                rv+= 5;
            if(b[233]=='r')
                rv+= 10;
            if(b[248]=='r')
                rv+= 10;
            if(b[249]=='r')
                rv+= 5;
            if(b[250]=='r')
                rv+= 10;
            if(b[266]=='r')
                rv+= 10;
            if(b[267]=='r')
                rv+= 10;
            if(b[284]=='r')
                rv+= 10;
        case 2 :
            for(i=0;i<289;i++)
            {
                if(b[i]=='r')
                {
                    rn = i/17;
                    mv = abs(i - rn*17.5 - 4);
                    rv -= mv;
                }
                else if(b[i]=='o')
                {
                    rn = i/17;
                    mv = abs(i - rn*17.5 - 4);
                    rv += mv;
                }
            }
        case 1 :
            for(i=0;i<289;i++)
            {
                if(b[i]=='r')
                {
                    rn = i/17;
                    rv+=rn*h23_p1;
                }
                else if(b[i]=='o')
                {
                    rn = 16-i/17;
                    rv-=rn*h23_p1;
                }
            }
            break;
    }
    if(player=='r')
        return(rv);
    return(-1*rv);
}

char OPP(char a)
{
    if(a=='r')
        return ('o');
    return('r');
}

void Move_Gen(char* b, char player, char** &nb, int& no_nb)
{
    no_nb=0;
    int c=0;
    int j,i;
    bool arr[289];
    int positions[10];
    for(i=0;i<289;i++)
        if(b[i]==player)
            positions[c++]=i;

    Copy(b,boardconfig);

    nb = new char*[100];

    for(i=0;i<10;i++)
    {
        getallowedmoves(positions[i],arr);
        for(j=0;j<289;j++)
            if(
                (arr[j])
                && ( !opt
                     || (player=='r' && (j/17 - positions[i]/17) >=0)
                     || (player=='o' && (j/17 - positions[i]/17) <=0)
                   )
                &&
                !(
                    (  player=='r'
                       && ((positions[i]==231 && j==232) || (positions[i]==232 && j==231))
                    )
                    ||(  player=='o'
                         && ((positions[i]==56 && j==57) || (positions[i]==57 && j==56))
                      )
                )
            )

            {
                nb[no_nb]=new char[289];
                Copy(b,nb[no_nb]);
                nb[no_nb][positions[i]] = 'c';
                nb[no_nb][j] = player;
                //c++;
                noofnodes++;
                no_nb++;
                if(no_nb>99)
                {
                    message("Movegen overflow");
                    return;
                }
            }
    }

    //p("No of States ",no_nb,"");

    /*    c=0;
        // for each piece generate all moves
        for(i=0;i<10;i++)
        {
           //getallowedmoves(positions[i],arr);
           for(j=0;j<289;j++)
           	if(
               	(arr[i][j])
                   && ( !opt
                   	|| (player=='r' && (j/17 - positions[i]/17) >=0)
    				|| (player=='o' && (j/17 - positions[i]/17) <=0)
                       )
                   )
                  {
    	        Copy(b,nb[c]);
    	        nb[c][positions[i]] = 'c';
    	        nb[c][j] = player;
                   c++;
                   noofnodes++;
       	      }
        }  */

    //exit

}

int ABA(char* b, int depth, char player, int ut, int pt,int sef,int &d)
{
    Copy(b,boardconfig);
    if(win())
    {
        d = depth;
        return(SEF(b,player,sef));
    }
    if(depth>=DEEP_ENOUGH)
    {
        d = depth;
        return(SEF(b,player,sef));
    }
    char** nb;
    int no_nb;
    int i,j,t;
    int nv;
    Move_Gen(b,player,nb,no_nb);

    if(no_nb==0)
    {
        d = depth;
        return(SEF(b,player,sef));
    }

    int value[100],pos[100];
    for(i=0;i<no_nb;i++)
        pos[i]=i;

    //sort
    if(sort)
    {
        for(i=0;i<no_nb;i++)
        {
            value[i]=SEF(nb[i],player,sef);
        }

        for(i=0;i<no_nb-1;i++)
            for(j=i+1;j<no_nb;j++)
            {
                if(value[pos[i]]<value[pos[j]])
                {
                    t=pos[i];
                    pos[i]=pos[j];
                    pos[j]=t;

                }
            }

    }
    else if(best)
    {
        for(i=0;i<no_nb;i++)
        {
            value[i]=SEF(nb[i],player,sef);
        }

        i=0;
        for(j=i+1;j<no_nb;j++)
        {
            if(value[pos[i]]<value[pos[j]])
            {
                t=pos[i];
                pos[i]=pos[j];
                pos[j]=t;

            }
        }

    }



    for(i=0;i<no_nb;i++)
    {
        //	sprintf(buffer,"nn :  %s %d %d",nb[i],depth,i);
        //	Copy(nb[i],boardconfig);
        // cc->paintboard();
        // message(buffer);
        nv = -1*ABA(nb[pos[i]],depth+1,OPP(player),-1*pt,-1*ut,sef,d);
        if(nv>pt)
            pt = nv;
        if(pt>=ut)
        {
            for(i=0;i<no_nb;i++)
                delete[] nb[i];
            delete[] nb;
            return(pt);
        }
    }
    for(i=0;i<no_nb;i++)
        delete[] nb[i];
    delete[] nb;
    return(pt);
}



void AB(char* b, int depth, char player,int sef,char* rv)
{
    int i,j,t;
    char** nb;
    int no_nb;
    int nv;
    int pt = -1*INF;
    int ut = INF;
    Move_Gen(b,player,nb,no_nb);

    int value[100],pos[100];
    for(i=0;i<no_nb;i++)
        pos[i]=i;

    //sort
    if(sort)
    {
        for(i=0;i<no_nb;i++)
        {
            value[i]=SEF(nb[i],player,sef);
        }

        for(i=0;i<no_nb-1;i++)
            for(j=i+1;j<no_nb;j++)
            {
                if(value[pos[i]]<value[pos[j]])
                {
                    t=pos[i];
                    pos[i]=pos[j];
                    pos[j]=t;

                }
            }

    }
    else if(best)
    {
        for(i=0;i<no_nb;i++)
        {
            value[i]=SEF(nb[i],player,sef);
        }

        i=0;
        for(j=i+1;j<no_nb;j++)
        {
            if(value[pos[i]]<value[pos[j]])
            {
                t=pos[i];
                pos[i]=pos[j];
                pos[j]=t;

            }
        }

    }

    int d;

    if(no_nb==0)
    {
        Copy(b,rv);
        return;
    }
    int d1 = DEEP_ENOUGH;
    for(i=0;i<no_nb;i++)
    {
        //sprintf(buffer,"d1 :  %s",nb[i]);
        //Copy(nb[i],boardconfig);
        //cc->paintboard();
        // message(buffer);
        nv = -1*ABA(nb[pos[i]],depth+1,OPP(player),-1*pt,-1*ut,sef,d);
        if((nv>pt) ||((nv==pt)&&(d1>d)))
        {
            d1 = d;
            pt = nv;
            Copy(nb[pos[i]],rv);
        }
    }
    for(i=0;i<no_nb;i++)
        delete[] nb[i];
    delete[] nb;
    return;
}


void computenextmove()
{

    bool positions[289];
    int i;
    noofnodes=0;

    struct timeb t1,t2;
    ftime(&t1);


    //get all computer positions
    int computer_positions[10];
    int c=0;
    for(i=0;i<289;i++)
    {
        if(boardconfig[i]==computerpiece)
            computer_positions[c++]=i;
    }



    if(computerheuristic[currentturn]==RANDOM)
    {

        //message("Computer thinking randomly");

        // now move randomly for a piece
        bool tomove=true;
        while(tomove)
        {
            int p=random(10);
            getallowedmoves(computer_positions[p],positions);
            for(i=0;i<289;i++)
                if(positions[i] && random(10)>=7) // move now with prob 0.3
                {
                    from=computer_positions[p];
                    to=i;
                    tomove=false;
                    break;
                }
        }

    } // RANDOM HEURISTIC

    if(computerheuristic[currentturn]==AB1 || computerheuristic[currentturn]==AB2 || computerheuristic[currentturn]==AB3 || computerheuristic[currentturn]==AB4)
    {

        //message("Computer thinking randomly");

        // now move randomly for a piece
        bool tomove=true;
        //    sprintf(buffer,"boardconfig :  %s",boardconfig);
        //  message(buffer);
        char rv[289];
        int heuristic=-1;
        if(computerheuristic[currentturn]==AB1)
            heuristic=1;
        if(computerheuristic[currentturn]==AB2)
            heuristic=2;
        if(computerheuristic[currentturn]==AB3)
            heuristic=3;
        if(computerheuristic[currentturn]==AB4)
            heuristic=4;

        char orgbc[289];
        Copy(boardconfig,orgbc);
        AB(boardconfig,0,computerpiece,heuristic,rv);
        //     sprintf(buffer,"rv :  %s",rv);
        //  message(buffer);
        for(i=0;i<289;i++)
        {
            if(orgbc[i]=='c' && rv[i]==computerpiece)
                to=i;
            if(orgbc[i]==computerpiece && rv[i]=='c')
                from=i;

        }
        Copy(orgbc,boardconfig);
    } // AB1 HEURISTIC



    //  sprintf(buffer,"Moving from %d to %d",from,to);
    //  message(buffer);

    ftime(&t2);


    boardconfig[to]=boardconfig[from];
    boardconfig[from]='c';

    cc->blinktimer->Enabled=true;

    // wait for blinking to be over
    while(cc->blinktimer->Enabled)
    {

        MSG message;
        if(::PeekMessage(&message,NULL,0,0,PM_REMOVE))
        {
            ::TranslateMessage(&message);
            ::DispatchMessage(&message);
        }

    }

    timet=t2.time*1000+t2.millitm-(t1.time*1000+t1.millitm);

    // update commentary
    if(computerpiece=='o')
    {
        sprintf(buffer,"Nodes : %ld",noofnodes);
        commentarydlg->noofnodes1label->SetTextBuf(buffer);

        totalnodeso+=noofnodes;
        noofmoveso++;
        totaltimeo+=timet;

        sprintf(buffer,"Total Nodes : %ld",totalnodeso);
        commentarydlg->totalnodes1->SetTextBuf(buffer);

        sprintf(buffer,"Average Nodes : %ld",totalnodeso/noofmoveso);
        commentarydlg->average1->SetTextBuf(buffer);

        sprintf(buffer,"Time : %ld",timet);
        commentarydlg->time1->SetTextBuf(buffer);

        sprintf(buffer,"Total Time : %ld",totaltimeo);
        commentarydlg->totaltime1->SetTextBuf(buffer);

        sprintf(buffer,"Average Time : %ld",totaltimeo/noofmoveso);
        commentarydlg->averagetime1->SetTextBuf(buffer);

    }
    if(computerpiece=='r')
    {
        sprintf(buffer,"Nodes : %ld",noofnodes);
        commentarydlg->noofnodes2label->SetTextBuf(buffer);
        totalnodesr+=noofnodes;
        noofmovesr++;
        totaltimer+=timet;

        sprintf(buffer,"Total Nodes : %ld",totalnodesr);
        commentarydlg->totalnodes2->SetTextBuf(buffer);

        sprintf(buffer,"Average Nodes : %ld",totalnodesr/noofmovesr);
        commentarydlg->average2->SetTextBuf(buffer);

        sprintf(buffer,"Time : %ld",timet);
        commentarydlg->time2->SetTextBuf(buffer);

        sprintf(buffer,"Total Time : %ld",totaltimer);
        commentarydlg->totaltime2->SetTextBuf(buffer);

        sprintf(buffer,"Average Time : %ld",totaltimer/noofmovesr);
        commentarydlg->averagetime2->SetTextBuf(buffer);



    }




}





// this function paints the board based on the current configuration
void __fastcall Tcc::paintboard()
{
    // Draw the board based on board configuration
    int i,x,y;
    board->Canvas->Pen->Color=clWhite;
    board->Canvas->Pen->Width=1;
    board->Canvas->Brush->Style=bsSolid;
    for(i=0;i<289;i++)
    {
        get_position(i,x,y);
        if(boardconfig[i]=='r')
            board->Canvas->Brush->Color=clRed;
        if(boardconfig[i]=='g')
            board->Canvas->Brush->Color=clOlive;
        if(boardconfig[i]=='p')
            board->Canvas->Brush->Color=clPurple;
        if(boardconfig[i]=='o')
            board->Canvas->Brush->Color=clGreen;
        if(boardconfig[i]=='b')
            board->Canvas->Brush->Color=clBlue;
        if(boardconfig[i]=='y')
            board->Canvas->Brush->Color=clAqua;
        if(boardconfig[i]=='c' || boardconfig[i]=='m')
            board->Canvas->Brush->Color=clSilver;

        if(boardconfig[i]=='0')
            board->Canvas->Brush->Color=clWhite;


        board->Canvas->Ellipse(x-2,y-2,x+squaresize+2,y+squaresize+2);

        if(boardconfig[i]=='m')
        {
            board->Canvas->Brush->Color=clWhite;
            board->Canvas->Ellipse(x+2,y+2,x+squaresize-2,y+squaresize-2);
        }


    }

    // Draw clicked Position
    if(squareposclicked>=0)
    {
        get_position(squareposclicked,x,y);
        board->Canvas->Pen->Color=clBlack;
        board->Canvas->Pen->Width=1;

        board->Canvas->Brush->Style=bsClear;
        board->Canvas->Ellipse(x-2,y-2,x+squaresize+2,y+squaresize+2);
    }

}



//---------------------------------------------------------------------------
void init()
{
    int i;

    for(i=0;i<289;i++)
        boardconfig[i]='0';

    //red
    boardconfig[4]='r';
    boardconfig[21]='r';
    boardconfig[22]='r';
    boardconfig[38]='r';
    boardconfig[39]='r';
    boardconfig[40]='r';
    boardconfig[55]='r';
    boardconfig[56]='r';
    boardconfig[57]='r';
    boardconfig[58]='r';

    //green
    boardconfig[77]='g';
    boardconfig[78]='g';
    boardconfig[79]='g';
    boardconfig[80]='g';
    boardconfig[95]='g';
    boardconfig[96]='g';
    boardconfig[97]='g';
    boardconfig[113]='g';
    boardconfig[114]='g';
    boardconfig[131]='g';

    //purple
    boardconfig[166]='p';
    boardconfig[183]='p';
    boardconfig[184]='p';
    boardconfig[200]='p';
    boardconfig[201]='p';
    boardconfig[202]='p';
    boardconfig[217]='p';
    boardconfig[218]='p';
    boardconfig[219]='p';
    boardconfig[220]='p';

    //orange
    boardconfig[230]='o';
    boardconfig[231]='o';
    boardconfig[232]='o';
    boardconfig[233]='o';
    boardconfig[248]='o';
    boardconfig[249]='o';
    boardconfig[250]='o';
    boardconfig[266]='o';
    boardconfig[267]='o';
    boardconfig[284]='o';

    //blue
    boardconfig[157]='b';
    boardconfig[174]='b';
    boardconfig[175]='b';
    boardconfig[191]='b';
    boardconfig[192]='b';
    boardconfig[193]='b';
    boardconfig[208]='b';
    boardconfig[209]='b';
    boardconfig[210]='b';
    boardconfig[211]='b';

    //yellow
    boardconfig[68]='y';
    boardconfig[69]='y';
    boardconfig[70]='y';
    boardconfig[71]='y';
    boardconfig[86]='y';
    boardconfig[87]='y';
    boardconfig[88]='y';
    boardconfig[104]='y';
    boardconfig[105]='y';
    boardconfig[122]='y';

    // now the black part ( center part )

    for(i=68;i<=80;i++)
        boardconfig[i]='c';
    for(i=86;i<=97;i++)
        boardconfig[i]='c';
    for(i=104;i<=114;i++)
        boardconfig[i]='c';
    for(i=122;i<=131;i++)
        boardconfig[i]='c';
    for(i=157;i<=166;i++)
        boardconfig[i]='c';
    for(i=174;i<=184;i++)
        boardconfig[i]='c';
    for(i=191;i<=202;i++)
        boardconfig[i]='c';
    for(i=208;i<=220;i++)
        boardconfig[i]='c';
    for(i=140;i<=148;i++)
        boardconfig[i]='c';


    // other config
    turnconfig=0;
    cc->blinktimer->Enabled=false;

    // enter game loop

}

__fastcall Tcc::Tcc(TComponent* Owner)
        : TForm(Owner)
{
    // Init boardconfig
    init();

    Top=0;
    Left=0;

}


//---------------------------------------------------------------------------
void __fastcall Tcc::FormPaint(TObject *Sender)
{

//    paintboard();


}
//---------------------------------------------------------------------------
void __fastcall Tcc::boardMouseDown(TObject *Sender, TMouseButton Button,
                                    TShiftState Shift, int X, int Y)
{

    if(!playermove)
        return; // computer is thinking

    int i,x,y;
    static int prevsquareposclicked=-1;
    bool allowedmoves[289];


    squareposclicked=-1;
    for(i=0;i<289;i++)
    {
        get_position(i,x,y);
        if(X>x && X<x+squaresize && Y>y && Y<y+squaresize)
        {
            squareposclicked=i;
            break;
        }
    }

    if(squareposclicked==-1)
        return;
    // clear all allowed moves

    for(i=0;i<289;i++)
        allowedmoves[i]=false;


    if(turnconfig==1) // player's second move
    {


        if(boardconfig[squareposclicked]=='m') // check for validity for this move
        {
            // clear all m's
            for(i=0;i<289;i++)
                if(boardconfig[i]=='m')
                    boardconfig[i]='c';

            // allowed. Now move the piece
            boardconfig[prevsquareposclicked]='c';
            boardconfig[squareposclicked]=playerpiece;

            // move is over
            turnconfig=0;   // player move is over

            sprintf(buffer,"Player %d move over",currentturn+1);
            statuslabel->SetTextBuf(buffer);

            paintboard();

            moveover=true;
            gametimer->Enabled=true;
            return;

        }

        // if cancelling move

        if(boardconfig[squareposclicked]==playerpiece)
        {
            turnconfig=0;

        }



    }

    if(turnconfig==0) // player's first move
    {
        if(boardconfig[squareposclicked]!=playerpiece) // not a player's piece
            squareposclicked=-1;
        else
        {
            // clear all m's
            for(i=0;i<289;i++)
                if(boardconfig[i]=='m')
                    boardconfig[i]='c';

            getallowedmoves(squareposclicked,allowedmoves); // get current allowed moves

            // highlight all allowable moves
            for(i=0;i<289;i++)
            {
                if(boardconfig[i]=='m')
                    boardconfig[i]='c';

                if(allowedmoves[i]==true)
                    boardconfig[i]='m';
            }

            prevsquareposclicked=squareposclicked;
            sprintf(buffer,"Player %d Second Move" , currentturn+1);
            statuslabel->SetTextBuf(buffer);

            turnconfig=1;  //  advance to allow second turn
            paintboard();
        }
    }



}
//---------------------------------------------------------------------------
// player 0 is orange , player 1 is red
void __fastcall Tcc::gametimerTimer(TObject *Sender)
{

    MSG messag;
    if(::PeekMessage(&messag,NULL,0,0,PM_REMOVE))
    {
        ::TranslateMessage(&messag);
        ::DispatchMessage(&messag);
    }

    if(paused)
        return;

    switch(currentturn)
    {
        case 0:
            // see if player or computer
            if (players[currentturn]==PLAYER)
            {
                if(moveover==false)
                {
                    playermove=true;
                    playerpiece='o';

                    sprintf(buffer,"Player %d First Move" , currentturn+1);
                    statuslabel->SetTextBuf(buffer);

                    gametimer->Enabled=false; // disable timer until move complete
                    return;
                }

                else if(moveover==true) // move is done go to next move now
                {
                    playermove=false;
                    moveover=false;

                }
            }

            else if (players[currentturn]==COMPUTER)
            {

                // do the move
                computerpiece='o';
                gametimer->Enabled=false;

                sprintf(buffer,"Computer Player %d Thinking" , currentturn+1);
                statuslabel->SetTextBuf(buffer);
                MSG message;
                if(::PeekMessage(&message,NULL,0,0,PM_REMOVE))
                {
                    ::TranslateMessage(&message);
                    ::DispatchMessage(&message);
                }

                // set computer player parameters

                opt = opto;
                DEEP_ENOUGH=plieso;
                sort=sorto;
                best=besto;

                computenextmove();

                sprintf(buffer,"Computer Player %d Moved" , currentturn+1);
                statuslabel->SetTextBuf(buffer);

                // move computed
                moveover=false;
                paintboard();
                gametimer->Enabled=true;

            }


            // check for win
            if(win())
            {
                gametimer->Enabled=false;
                gameinprogress=false;
                gameinprogresslabel->SetTextBuf("Player 1 Wins !!");

                commentarydlg->gameinprogresslabel->Visible=false;
                commentarydlg->win2label->Visible=false;
                commentarydlg->win1label->Visible=true;


                return;

            }

            currentturn=1;

            break;

        case 1:
            sprintf(buffer,"currenturn=2  player %d",players[currentturn]);
            //gametimer->Enabled=false;
            //message(buffer);


            // see if player or computer
            if (players[currentturn]==PLAYER)
            {
                //message("Player 2s move");
                if(moveover==false)
                {
                    //message("Player 2s move");
                    playermove=true;
                    playerpiece='r';
                    sprintf(buffer,"Player %d First Move" , currentturn+1);
                    statuslabel->SetTextBuf(buffer);

                    gametimer->Enabled=false; // disable timer until move complete
                    return;
                }

                else if(moveover==true) // move is done go to next move now
                {
                    playermove=false;
                    moveover=false;
                }
            }

            else if (players[currentturn]==COMPUTER)
            {

                // do the move
                computerpiece='r';

                gametimer->Enabled=false;

                sprintf(buffer,"Computer Player %d Thinking" , currentturn+1);
                statuslabel->SetTextBuf(buffer);

                //give  some time

                MSG message;
                if(::PeekMessage(&message,NULL,0,0,PM_REMOVE))
                {
                    ::TranslateMessage(&message);
                    ::DispatchMessage(&message);
                }


                // set computer player parameters

                opt = optr;
                DEEP_ENOUGH=pliesr;
                sort=sortr;
                best=bestr;


                computenextmove();

                sprintf(buffer,"Computer Player %d Moved" , currentturn+1);
                statuslabel->SetTextBuf(buffer);

                // move computed
                moveover=false;
                paintboard();
                gametimer->Enabled=true;

            }
            if(win())
            {

                gametimer->Enabled=false;
                gameinprogress=false;
                gameinprogresslabel->SetTextBuf("Player 2 wins !!");

                commentarydlg->gameinprogresslabel->Visible=false;
                commentarydlg->win2label->Visible=true;
                commentarydlg->win1label->Visible=false;

                return;
            }

            currentturn=0;


    }     // switch case

}


//---------------------------------------------------------------------------
void __fastcall Tcc::blinktimerTimer(TObject *Sender)
{
    // Draw the board based on board configuration
    static int count=0;
    int x,y;


    if(count==blinkcount*2)
    {
        count=0;
        blinktimer->Enabled=false;
        return;
    }


    if(count%2==0)
        board->Canvas->Pen->Color=clBlack;
    else
        board->Canvas->Pen->Color=clWhite;
    board->Canvas->Pen->Width=1;

    board->Canvas->Brush->Style=bsClear;

    //blink from
    get_position(from,x,y);
    board->Canvas->Ellipse(x-2,y-2,x+squaresize+2,y+squaresize+2);

    // blick to
    get_position(to,x,y);
    board->Canvas->Ellipse(x-2,y-2,x+squaresize+2,y+squaresize+2);
    count++;
}
//---------------------------------------------------------------------------
void __fastcall Tcc::btnConfigureClick(TObject *Sender)
{


    ConfigDlg->player1->ItemIndex=players[0];
    ConfigDlg->player2->ItemIndex=players[1];

    //set heuristics
    ConfigDlg->heuristic1->ItemIndex=computerheuristic[0];
    ConfigDlg->heuristic2->ItemIndex=computerheuristic[1];


    //optimization of movegen
    ConfigDlg->optmovegen1->Checked=opto;
    ConfigDlg->optmovegen2->Checked=optr;

    //sort moves
    ConfigDlg->sortmoves1->Checked=sorto;
    ConfigDlg->sortmoves2->Checked=sortr;

    //best moves
    ConfigDlg->bestmovefirst1->Checked=besto;
    ConfigDlg->bestmovefirst2->Checked=bestr;


    if(ConfigDlg->ShowModal()==mrCancel)
        return;

    if(ConfigDlg->player1->ItemIndex==1)
        players[0]=COMPUTER;
    else
        players[0]=PLAYER;

    if(ConfigDlg->player2->ItemIndex==1)
        players[1]=COMPUTER;
    else
        players[1]=PLAYER;



    //set heuristics
    computerheuristic[0]=ConfigDlg->heuristic1->ItemIndex;
    computerheuristic[1]=ConfigDlg->heuristic2->ItemIndex;


    //optimization of movegen
    opto=ConfigDlg->optmovegen1->Checked;
    optr=ConfigDlg->optmovegen2->Checked;

    //sort moves
    sorto=ConfigDlg->sortmoves1->Checked;
    sortr=ConfigDlg->sortmoves2->Checked;

    //best moves
    besto=ConfigDlg->bestmovefirst1->Checked;
    bestr=ConfigDlg->bestmovefirst2->Checked;

    // plies
    plieso=atoi(ConfigDlg->plies1->Text.c_str());
    pliesr=atoi(ConfigDlg->plies2->Text.c_str());



    //set blink test
    blinkcount=atoi(ConfigDlg->noofblinks->Text.c_str());
}

//---------------------------------------------------------------------------
void __fastcall Tcc::startbtnClick(TObject *Sender)
{
    gametimer->Enabled=false;

    init();
    paintboard();
    gameinprogress=true;
    gameinprogresslabel->SetTextBuf("Game in Progress : Yes");


    commentarydlg->gameinprogresslabel->Visible=true;
    commentarydlg->win2label->Visible=false;
    commentarydlg->win1label->Visible=false;

    currentturn=0;

    //init stats
    noofnodes=timet=totalnodeso=totalnodesr=totaltimeo=totaltimer=noofmoveso=noofmovesr=0;

    gametimer->Enabled=true;


    // set commentary
    if(players[0]==COMPUTER)
    {
        commentarydlg->player1label->SetTextBuf("Player 1 is computer");
        sprintf(buffer,"Heur : %s",heuristics[computerheuristic[0]]);
        commentarydlg->heuristic1label->SetTextBuf(buffer);

        if(opto)
            commentarydlg->optmovegen1label->SetTextBuf("Optimization : Yes");
        else
            commentarydlg->optmovegen1label->SetTextBuf("Optimization : No");

        sprintf(buffer,"Plies : %d",plieso);

        commentarydlg->plies1label->SetTextBuf(buffer);

        if(sorto)
            commentarydlg->selection1->SetTextBuf("Mode : Sort");
        else if(besto)
            commentarydlg->selection1->SetTextBuf("Mode : Best");
        else
            commentarydlg->selection1->SetTextBuf("Mode : None");




    }
    else
    {
        commentarydlg->player1label->SetTextBuf("Player 1 is human");

    }

    if(players[1]==COMPUTER)
    {
        commentarydlg->player2label->SetTextBuf("Player 2 is computer");
        sprintf(buffer,"Heur : %s",heuristics[computerheuristic[1]]);
        commentarydlg->heuristic2label->SetTextBuf(buffer);
        if(optr)
            commentarydlg->optmovegen2label->SetTextBuf("Optimization : Yes");
        else
            commentarydlg->optmovegen2label->SetTextBuf("Optimization : No");

        sprintf(buffer,"Plies : %d",pliesr);

        commentarydlg->plies2label->SetTextBuf(buffer);

        if(sortr)
            commentarydlg->selection2->SetTextBuf("Mode : Sort");
        else if(bestr)
            commentarydlg->selection2->SetTextBuf("Mode : Best");
        else
            commentarydlg->selection2->SetTextBuf("Mode : None");



    }
    else
    {
        commentarydlg->player2label->SetTextBuf("Player 2 is human");

    }

}
//---------------------------------------------------------------------------
void __fastcall Tcc::pausebtnClick(TObject *Sender)
{
    if(!gameinprogress)
        return;
    if(!paused)
    {
        paused=true;
        gameinprogresslabel->SetTextBuf("Game Paused");

    }
    else
    {
        paused=false;
        gameinprogresslabel->SetTextBuf("Game in Progress : Yes");


    }

}
//---------------------------------------------------------------------------
void __fastcall Tcc::commentarybtnClick(TObject *Sender)
{

    commentarydlg->Visible=!commentarydlg->Visible;
    commentarydlg->Left = Left+ Width;
    commentarydlg->Top = Top;

}//---------------------------------------------------------------------------
void __fastcall Tcc::aboutbtnClick(TObject *Sender)
{

    AboutDlg->ShowModal();


}
//---------------------------------------------------------------------------


void __fastcall Tcc::btn_helpClick(TObject *Sender)
{
int result =(int)ShellExecute(0, "open",
                                  "index.htm", "", "",
                                  SW_SHOWNORMAL);
    if (result <= 32)
        ShowMessage("Unable to open help file index.htm");
}
//---------------------------------------------------------------------------

